; Termostat s ATTINY 2313

; Nacitanie symbolov
.Include "tn2313def.inc"

; Tabulka preruseni
.Org 0x0000
 Rjmp Reset
.Org OC1Aaddr
 RJmp aDisp_Server 
.Org 0x0013 
 Reset:

; Nacitanie utilit
.Include "Utility.asm"

; Nacitanie kniznice DS1820
.Include "DS1820.asm"

; Nacitanie kniznice MCP3201
.Include "mcp3201.asm"

; Nacitanie kniznice mxDisplej
.Include "mxDisp.asm"

; Rozlozenie pinov
; - PortB
; 0. - Seg-A
; 1. - Seg-F
; 2. - Seg-B
; 3. - Seg-G
; 4. - Seg-C
; 5. - Seg-H - Bodka
; 6. - Seg-D
; 7. - Seg-E
; - PortD
; 0. - RXD - Cidlo DS1820
; 1. - TXD - RELE
; 2. - Tlacitko 1
; 3. - Tlacitko 2
; 4. - Segment 2
; 5. - Segment 1
; 6. - Segment 3

; Premenne teploty
 .Def 	Temp = R22
 Ldi Temp	 , 25
 .Def 	Step = R23
 Ldi Step	 , 2

 ; nastavenie 8Mhz
 Ldi T		, 0b10000000
 Out ClkPr	, T
 Ldi T		, 0b00000000
 Out ClkPr	, T

 ; Nastavenie portu B
 Ldi T		, 0xFF
 Out DDRB	, T
 Out PortB	, T
 ; Nastavenie portu D
 Ldi T		, 0b01110010
 Out DDRD	, T
 Ldi T		, 0b00001100
 Out PortD	, T
 
 ; Nastavenie Citaca
 Ldi 	T		, 0b00000000	; 00 - CTC mode
 Out	TCCR1A	, T				; - Odoslanie
 Ldi 	T		, 0b00001001	; Preddelicka a CTC mod
 Out 	TCCR1B	, T				; - Odoslanie
 Ldi 	T		, 30			; Nastavenie hodnoty timera
 Out	OCR1AH	, T				; - Odoslanie
 Ldi 	T		, 70			; Nastavenie hodnoty timera
 Out	OCR1AL	, T				; - Odoslanie
 Ldi	T		, 0b01000000	; Nastavenie OCIE1A
 Out 	TIMSK	, T				; - Odoslanie
  

App_Init:

 Clr F

 ; Inicializacia DS
 DS_Init
   
 ; Ak sa cidlo nepouziva, obsluz USART 
 Sbrc F		, 3
  Rjmp App_AD
 ; Rjmp App_USART
 
; Komunikacia s DS1820 ------------------------------------ Termostat -
App_Temp:
 
 Cli 
 
 ; Nacitanie teploty z EEPROM
 EEPROM_Read [0]
 Sbrc	A	, 7
  Ldi 	A	, 80
 Mov	Temp, A 

 ; Povolenie prerusenia
 Sei
  
; Obsluha teplotneho cidla - Termostat
App_Temp_Init:

 ; Blikanie
 Blink_Enable
 ; Konverzia 
 Mov  A		, Temp
 Andi F		, 0b11111101
 Cli
 DispNum
 ; Mazanie prednych nul a znamienko minus
 DispTemp 
 ; Bodka podla typu cidla
 Bst  F		, 2
 Bld  Seg3	, 7
 Sei
 
App_Temp_Loop:
  
 ; Nacitanie teploty
 DS_Load_1S
 ; Konverzia podla typu B/S na teplotu a Flags
 DS_Get
 ; Flag Register teplotneho cidla
 ; F : 0 - 1/2						; Nastavuje DS_Read_1S
 ; F : 1 - Minus					; Nastavuje DS_Read_1S
 ; F : 2 - Architektura ..B..		; Nastavuje DS_Init
 ; F : 3 - Cidlo nieje pritomne		; Nasatvuje DS_Init, DS_Reset
 ; Klavesnica
 ; F : 4 - Mod nastavovania			; Nastavuje ATD_Button
 ; F : 5 - Klavesa stlacena			; Nastavuje ATD_Button
 ; Displej
 ; F : 6 - Blikanie displeja		; Nasatvuje Aplikacia
 ; F : 7 - Oscilator blikania		; Nasatvuje Disp_Server

 ; Cidlo nieje pritomne; vykresli "Err"
 Sbrs F		, 3		
  Rjmp App_Error_End
   Ldi T	, 14
   Mov Seg1	, T
   Ldi T	, LedCharR
   Mov Seg2	, T
   Mov Seg3	, T
   Rjmp App_Temp_Loop   
  App_Error_End:
 
 ; Slucka cakania
 Ldi 	B		, 50    ; 25 x 4ms -> >1000ms
  ATD_Loop:	 			; Slucka
  Dec	B		 		; Odpocitanie jednej
   Breq ATD_End			; Ak prejde nulov tak ukonc proceduru 
    Delay_us [40000]	; - Cakaj 40mS
    ; Nacitanie tlacitok
    In  T	, PinD		; Nacitanie portu
    Sbrs T	, 2			; - Obsluha tlacitka 1
     Rjmp ATD_Button1	; -- Skok na obsluhu
    Sbrs T	, 3			; - Obsluha tlacitka 2
     Rjmp ATD_Button2	; -- Skok na obsluhu 
    Andi F	, 0b11011111; Maska tlacidiel    
    Rjmp	ATD_Loop	; ^ -- Slucka
  ATD_End:
 ; Ukoncenie blikania
 Blink_Disable
 
 ; Az po druhom kroku ukaze teplotu
 Dec Step
  Brne App_Temp; _Init
 Ldi Step  , 1 

 ; Zopnutie rele
 Sbrc F		, 1			; Zistenie minusovej teploty
  Rjmp ATC_On
 Cp	A		, Temp		; Porovnanie teploty
  Brlo ATC_On			; - Mensia - skoc na Zapnut
   Cbi PortD, 1			; -- Vypni rele
   Rjmp ATC_Off_end
 ATC_On:
   Sbi PortD, 1			; -- Zapni rele
 ATC_Off_end:
 
 ; Nieje chyba prepocitaj hodnotu na display
 Cli
 ; Konverzia BIN -> DEC
 DispNum
 ; Mazanie prednych nul a znamienko minus
 DispTemp 
 ; Povolenie prerusenia
 ; - Prerusenie bolo behom konverzie zakazne.
 Sei
 
 ; Ulozenie teploty do EEPROM
 Sbrs F		, 4
  Rjmp ATE_End
  Andi F	, 0b11101111
  Mov A		, Temp
  RCAll eWrite
 ATE_End: 

 ; Koniec podprogramu slucka
 Rjmp App_Temp_Loop
 
 ; Obsluha tlacitiel 
 ATD_Button1:
  Sbrc F	, 5
   Rjmp App_Temp_Init  
  Ori F		, 0b00110000
  Cpi Temp	, 2
   Brlo App_Temp_Init
  Dec Temp
 Rjmp App_Temp_Init
 
 ATD_Button2:
  Sbrc F	, 5
   Rjmp App_Temp_Init  
  Ori F		, 0b00110000
  Cpi Temp	, 120
   Brsh App_Temp_Init_lnk
    Inc Temp	  
 App_Temp_Init_lnk:   
 Rjmp App_Temp_Init

 ; Zapis do eeprom
 eWrite:
   EEPROM_Write [0]
 Ret

; Komunikacia USART ------------------------------------------- USART -
 App_USART:

 ; Nadpis
  Ldi T	, LedCharU
  Mov Seg1	, T
  Ldi T	, LedCharA
  Mov Seg2	, T
  Ldi T	, LedCharR
  Mov Seg3	, T

 
 ; Inicializacia
 Ldi	T		, 51			; BauntRage 9600
 Out	UBRRH	, Nul			; - Horny byte
 Out	UBRRL	, T				; - Dolny byte
 Ldi 	T		, 0b00011000	; Spustenie RX a TX
 Out	UCSRB	, T				; - Odoslanie
 Ldi	T		, 0b00000110	; Odosielanie 8 bit, 1x stop
 Out	UCSRC	, T				; - Odoslanie

App_USART_Loop:
  ; Usart
  Sbis UCSRA	, RXC		; Zistenie
   Rjmp App_USART_Loop
  In	A		, UDR		; Nacitanie Dat
 ; Posuvanie
 Cli
 Mov B		, Seg1
 Mov Seg1	, Seg2
 Mov Seg2	, Seg3
 Mov Seg3	, A
 Sei
 ; Odoslanie prveho bitu 
 auSend:
  Sbis	UCSRA	, UDRE		; Cakanie
   Rjmp auSend
  Out UDR		, B		; Odoslanie nulu
 ; Koniec
 Rjmp App_USART_Loop

; Komunikacia s MCP3201 -------------------------------- Prevodnik AD -
App_AD:

 ; Nacitanie a zistenie ci je MCP pritomne 
 mcAD_Read
 Andi XH	, 0b11100000	; Naska hornych bitov
 Cpi  XH	, 0b11000000	; - Porovnanie 
  Breq	App_AD_Loop			; -- Cidlo pritomne skoc na slucku AD
  
  ; Cidlo nepritomne skok na USAR
  Rjmp App_USART  

; Slucka ukazovatela AD
App_AD_Loop:
 
 ; Nacitanie 
 mcAD_Read
 
 ; Vypocet
 ; - Rolovanie - 3bity z XL -> XH
  Rol XL
  Rol XH
  Rol XL
  Rol XH
  Rol XL
  Rol XH
  Mov A	, XH
 
 ; zmazanie vlajky minus
  Andi F	, 0b11111101
 ; Vykreslenie 
  Cli
  ; Konverzia do DEC
  DispNum
  ; Zmazanie nul
  DispTemp
  Sei
 
 Rjmp App_AD_Loop
 
 
 .db "Napisal Vladimir Visnovsky (c) 2016 Lipany",0
