; Prebrane procedury z wMEGA

; Frekvencie	.DEFINE CPUFreqenci xxx
.equ f1Mhz		= 1
.equ f8Mhz		= 2
.equ f16Mhz		= 4 
.define	CpuFreqenci f8Mhz

 ; Zakladne registre
 ;.def	XH	= r27
 ;.def	XL	= r26
 ;.def	YH	= r29
 ;.def	YL	= r28
 ;.def	ZH	= r31
 ;.def	ZL	= r30
 ; Pre procedury
 .def	A	= r16
 .def	B	= r17
 .def	T	= r18
 .def 	F	= r19
 .def	H	= r25
 .def	L	= r24
 .def	Nul = r3
 Clr Nul
  
 ; Zasobnik
.Macro SetStack
 Ldi	T	, High(RAMEND)	; Adresa konca pamati H
 Out	SPH	, T
 Ldi	T 	, Low(RAMEND)	; Adresa konca pamati L
 Out	SPL	, T
.EndMacro
 
Rjmp uEnd 
 
; Delay --------------------------------------------------------- Delay
; Delay v us.
.Macro mDelay_us
 .message "Delay_us: Error of parametr in uSec. Delay_us [Word] max4095"
.EndMacro
.Macro mDelay_us_i
;.if CPUFreqenci = f1Mhz
; Ldi	L		, Low(@0/5)					; 1 cyklus
; Ldi	H		, High(@0/5)				; 1 cyklus
;.elif CPUFreqenci = f8Mhz
 Ldi	L		, Low(@0)			; 1 cyklus
 Ldi	H		, High(@0)			; 1 cyklus 
;.elif CPUFreqenci = f16Mhz
; Ldi	L		, Low((((@0/5)*16)			; 1 cyklus
; Ldi	H		, High((((@0/5)*16)			; 1 cyklus
;.endif 
 Delay_us_Loop_%:
  Nop
  Nop
  Nop
  Nop
  Sbiw  L		,1			; 2 cyklus
  Brne	Delay_us_Loop_%    	; 1 nakoniec, inac 2 cykly
.EndMacro
; Delay - telo zo vstupom HL
Delay_Body:
 Nop
 Nop
 Nop
 Nop
  Sbiw  L		,1			; 2 cyklus
 ; Subi	L		, 1
 ; Sbci  H		, 0
  Brne	Delay_Body    	; 1 nakoniec, inac 2 cykly
Ret
.Macro Delay_us
 .message "Delay_Parameter: Error of parameter. [word] max 4095"
.EndMacro
.Macro Delay_us_i
;.if CPUFreqenci = f1Mhz
; Ldi	L		, Low(@0/5)					; 1 cyklus
; Ldi	H		, High(@0/5)				; 1 cyklus
;.elif CPUFreqenci = f8Mhz
 Ldi	L		, Low(@0)				; 1 cyklus
 Ldi	H		, High(@0)		; 1 cyklus 
;.elif CPUFreqenci = f16Mhz
; Ldi	L		, Low((((@0/5)*16)			; 1 cyklus
; Ldi	H		, High((((@0/5)*16)			; 1 cyklus
;.endif 
 RCall Delay_Body 
.EndMacro
; 1 -> 13 cykly 
; 2 -> 13 + 4 cykly 
; 3 -> 13 + 8 cykly

; ------------------------------------------------------------------- 4.
; Makra
; - Zakladne
;   Vlozenie do akumulatora A (r16)
.Macro Acc
 .message "Acc: No parameter. Function ignored. Use: Acc [0xXX] or [rX]"
.EndMacro
.Macro Acc_i
 Ldi	A		, @0
.EndMacro
.Macro Acc_8
 Mov	A		, @0
.EndMacro

;   Parameter 8 bit. : Vlozenie do akumulatora A (r16)
.Macro Parameter
 .message "Parameter is A (r16)"
.EndMacro
.Macro Parameter_i
 Ldi	A		, @0
.EndMacro
.Macro Parameter_8
 Mov	A		, @0
.EndMacro
;   Parameter 16 bit. : Vlozenie do akumulatora H (r25), L (r24)
.Macro ParameterHL
 .message "Parameter is H:L (r25:r24) "
.EndMacro
.Macro ParameterHL_i
 Ldi	H		, High(@0)
 Ldi	L		, Low(@0)
.EndMacro
.Macro ParameterHL_8_8
 Mov	H		, @0
 Mov	L		, @1
.EndMacro
.Macro ParameterHL_16
 Mov	H		, @0
 Mov	L		, @1
.EndMacro
;   Parameter 16 bit. : Vlozenie do ZH:ZL
.Macro ParameterZ
 .message "Z <- H:L (r25:r24)"
 Mov	ZH		, H
 Mov	ZL		, L
.EndMacro
.Macro ParameterZ_i
 Ldi	ZH		, High(@0)
 Ldi	ZL		, Low(@0)
.EndMacro
.Macro ParameterZ_8_8
 Mov	ZH		, @0
 Mov	ZL		, @1
.EndMacro
.Macro ParameterZ_16
 Mov	ZH		, @0
 Mov	ZL		, @1
.EndMacro
;   Parameter 16 bit. : Vlozenie do XH:XL
.Macro ParameterX
 .message "X <- H:L (r25:r24)"
 Mov	XH		, H
 Mov	XL		, L
.EndMacro
.Macro ParameterX_i
 Ldi	XH		, High(@0)
 Ldi	XL		, Low(@0)
.EndMacro
.Macro ParameterX_8_8
 Mov	XH		, @0
 Mov	XL		, @1
.EndMacro
.Macro ParameterX_16
 Mov	XH		, @0
 Mov	XL		, @1
.EndMacro
;   Parameter 16 bit. : Vlozenie do YH:YL
.Macro ParameterY
 .message "Y <- H:L (r25:r24)"
 Mov	YH		, H
 Mov	YL		, L
.EndMacro
.Macro ParameterY_i
 Ldi	YH		, High(@0)
 Ldi	YL		, Low(@0)
.EndMacro
.Macro ParameterY_8_8
 Mov	YH		, @0
 Mov	YL		, @1
.EndMacro
.Macro ParameterY_16
 Mov	YH		, @0
 Mov	YL		, @1
.EndMacro
.Macro Address
 .message "Error: Must parameter!"
.EndMacro
.Macro Address_i
 Ldi	ZH		, High(@0<<1)
 Ldi	ZL		, Low(@0<<1)
.EndMacro
 

; --------------------------------------------------- Zasobnikove makra
; - Zasobnikove Makra
.Macro PushA
 Push	A
 In		A		, SREG
 Cli
 Push	A
 Push	T
 Push   ZL
 Push 	ZH
.EndMacro 
.Macro PopA
 Pop	ZH
 Pop	ZL
 Pop	T
 Pop	A
 Out 	SREG	, A 
 Pop	A
.EndMacro 

; -------------------------------------------------------------- EEPROM
; Cakanie, kym je pamat pripravena
.Macro EEPROM_Wait
 RCall eeWait
.EndMacro
eeWait:
 Sbic	EECR	, EEWE			; Ak je eeprom zanepraznena
 Rjmp	eeWait					; Cakaj!
 Ret
; Citanie
.Macro EEPROM_Read ; ( HL : Word - Adreasa; A : Byte - Data )
 EEPROM_Wait
 Out	EEAR	, L				; Vyslanie do EEPROM
 Sbi	EECR	, EERE			; Vlajka citania
 In		A		, EEDR			; Nacitanie spodneho bytu
.EndMacro
; Citanie z Adresy
; EEPROM_Read [word]
.Macro EEPROM_Read_i ; ( Word - Adreasa; A : Byte - Data )
 EEPROM_Wait
 Ldi 	T		, @0
 Out	EEAR	, T				; Vyslanie do EEPROM
 Sbi	EECR	, EERE			; Vlajka citania
 Nop
 In		A		, EEDR			; Nacitanie spodneho bytu
.EndMacro
; Zapis
.Macro EEPROM_Write ; ( HL : Word - Adreasa) : A  - Data 
 EEPROM_Wait
 Cli
 Out	EEAR	, L				; Vyslanie do EEPROM
 Out	EEDR	, A				; Vyslanie do EEPROM
 Sbi	EECR	, EEMWE			; Vlajka zapisu
 Sbi	EECR	, EEWE			; Vlajka zapisu
 Sei
.EndMacro
; Zapis
; - EEPROM_Write [Word]
.Macro EEPROM_Write_i ; ( Word - Adreasa) : A  - Data 
 EEPROM_Wait
 Cli
 Ldi	L		, @0
 Out	EEAR	, L				; Vyslanie do EEPROM
 Out	EEDR	, A				; Vyslanie do EEPROM
 Sbi	EECR	, EEMWE			; Vlajka zapisu
 Sbi	EECR	, EEWE			; Vlajka zapisu
 Sei
.EndMacro


uEnd:
